'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _createEventCallback = require('../utils/createEventCallback');

var _createEventCallback2 = _interopRequireDefault(_createEventCallback);

var _isShallowEqual = require('../utils/isShallowEqual');

var _isShallowEqual2 = _interopRequireDefault(_isShallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapContainerStyle = { width: '100%', height: '100%' };

/**
 * This module imports AMap libraries (JS API, JS UI API, and Loca), and creates a map scope.
 * All other map component should be descendant of this component.
 */
var AMap = (_temp = _class = function (_React$PureComponent) {
  _inherits(AMap, _React$PureComponent);

  _createClass(AMap, null, [{
    key: 'parseMapOptions',


    /**
     * Parse AMap.Map options.
     * Filter out event callbacks, the remainings are map options.
     */

    /**
     * AMap component accepts the following options to initialise AMap.
     * AMap has the same options as AMap.Map unless highlighted below.
     * {@link http://lbs.amap.com/api/javascript-api/reference/map}
     */
    value: function parseMapOptions(props) {
      var appKey = props.appKey,
          children = props.children,
          locaVersion = props.locaVersion,
          protocol = props.protocol,
          uiVersion = props.uiVersion,
          version = props.version,
          onComplete = props.onComplete,
          onClick = props.onClick,
          onDblClick = props.onDblClick,
          onMapMove = props.onMapMove,
          onHotspotClick = props.onHotspotClick,
          onHotspotOver = props.onHotspotOver,
          onHotspotOut = props.onHotspotOut,
          onMoveStart = props.onMoveStart,
          onMoveEnd = props.onMoveEnd,
          onZoomChange = props.onZoomChange,
          onZoomStart = props.onZoomStart,
          onZoomEnd = props.onZoomEnd,
          onMouseMove = props.onMouseMove,
          onMouseWheel = props.onMouseWheel,
          onMouseOver = props.onMouseOver,
          onMouseOut = props.onMouseOut,
          onMouseUp = props.onMouseUp,
          onMouseDown = props.onMouseDown,
          onRightClick = props.onRightClick,
          onDragStart = props.onDragStart,
          onDragging = props.onDragging,
          onDragEnd = props.onDragEnd,
          onResize = props.onResize,
          onTouchStart = props.onTouchStart,
          onTouchMove = props.onTouchMove,
          onTouchEnd = props.onTouchEnd,
          mapOptions = _objectWithoutProperties(props, ['appKey', 'children', 'locaVersion', 'protocol', 'uiVersion', 'version', 'onComplete', 'onClick', 'onDblClick', 'onMapMove', 'onHotspotClick', 'onHotspotOver', 'onHotspotOut', 'onMoveStart', 'onMoveEnd', 'onZoomChange', 'onZoomStart', 'onZoomEnd', 'onMouseMove', 'onMouseWheel', 'onMouseOver', 'onMouseOut', 'onMouseUp', 'onMouseDown', 'onRightClick', 'onDragStart', 'onDragging', 'onDragEnd', 'onResize', 'onTouchStart', 'onTouchMove', 'onTouchEnd']);

      var bounds = mapOptions.bounds;


      return _extends({}, mapOptions, {
        bounds: function () {
          /**
           * Bounds does not have any effect before AMap library has been loaded.
           * Bounds takes effect through calling setBounds function as long as AMap library has been
           * loaded.
           */
          if (window.AMap === void 0) return void 0;

          /**
           * The most anticipated value.
           */
          if (bounds instanceof window.AMap.Bounds) return bounds;

          /**
           * Transform [[soutWest], [northEast]] to AMap.Bounds instance.
           */
          if (bounds instanceof Array) {
            return new (Function.prototype.bind.apply(window.AMap.Bounds, [null].concat(_toConsumableArray(bounds))))();
          }

          return bounds;
        }(),
        /**
         * Memorise props.bounds.
         * We always create a new instance of AMap.Bounds if props.bounds is an array. Shallow
         * compare bounds always results unequal even if props.bounds does not change. boundsProp
         * memorises the original props.bounds. Comparing boundProp has a clear understanding
         * whether bounds has changed.
         */
        boundsProp: function () {
          /**
           * Bounds does not have any effect before AMap library has been loaded.
           * Bounds takes effect through calling setBounds function as long as AMap library has been
           * loaded.
           */
          if (window.AMap === void 0) return void 0;

          return bounds;
        }()
      });
    }

    /**
     * Create script tag to load some scripts.
     */

  }, {
    key: 'loadScript',
    value: function loadScript(src) {
      var scriptTag = document.createElement('script');
      scriptTag.type = 'text/javascript';
      scriptTag.src = src;

      document.head.appendChild(scriptTag);

      return new Promise(function (resolve) {
        scriptTag.onload = function () {
          return resolve();
        };
      });
    }

    /**
     * Create script tag to require AMap library.
     */

  }, {
    key: 'requireAMap',
    value: function requireAMap(_ref) {
      var appKey = _ref.appKey,
          protocol = _ref.protocol,
          version = _ref.version;

      var src = protocol + '://webapi.amap.com/maps?v=' + version + '&key=' + appKey;

      return AMap.loadScript(src);
    }

    /**
     * Create script tag to require AMapUI library.
     */

  }, {
    key: 'requireAMapUI',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
        var protocol = _ref3.protocol,
            version = _ref3.version;
        var src;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                src = protocol + '://webapi.amap.com/ui/' + version + '/main-async.js';
                _context.next = 3;
                return AMap.loadScript(src);

              case 3:

                window.initAMapUI();

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function requireAMapUI(_x) {
        return _ref2.apply(this, arguments);
      }

      return requireAMapUI;
    }()

    /**
     * Create script tag to require Loca library.
     */

  }, {
    key: 'requireLoca',
    value: function requireLoca(_ref4) {
      var appKey = _ref4.appKey,
          protocol = _ref4.protocol,
          version = _ref4.version;

      var src = protocol + '://webapi.amap.com/loca?key=' + appKey + '&v=' + version;

      return AMap.loadScript(src);
    }

    /**
     * Initialise map property with undefined.
     */

  }]);

  function AMap(props) {
    _classCallCheck(this, AMap);

    var _this = _possibleConstructorReturn(this, (AMap.__proto__ || Object.getPrototypeOf(AMap)).call(this, props));

    _this.state = {
      map: void 0
    };

    _this.mapOptions = AMap.parseMapOptions(_this.props);
    return _this;
  }

  /**
   * We get map conatiner element reference until this lifecycle method to instantiate
   * AMap map object.
   */


  _createClass(AMap, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initAMap();
    }

    /**
     * Update this.map by calling AMap.Map methods.
     */

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      /**
       * Hold all updates until map has been created.
       */
      if (this.map === void 0) return;

      var nextMapOptions = AMap.parseMapOptions(this.props);

      this.updateMapWithAPI('setZoom', this.mapOptions.zoom, nextMapOptions.zoom);
      this.updateMapWithAPI('setLabelzIndex', this.mapOptions.labelzIndex, nextMapOptions.labelzIndex);
      // Calling setLayers causes fatal exceptions
      // this.updateMapWithApi('setLayers', this.mapOptions.layers, nextMapOptions.layers);
      this.updateMapWithAPI('setCenter', this.mapOptions.center, nextMapOptions.center);
      this.updateMapWithAPI('setCity', this.mapOptions.city, nextMapOptions.city);
      /**
       * Comparing props.bounds instead of bounds because bounds are newly created everytime
       * even though props.bounds does not change.
       */
      this.updateMapWithAPI('setBounds', this.mapOptions.boundsProp, nextMapOptions.boundsProp, nextMapOptions.bounds);
      this.updateMapWithAPI('setLang', this.mapOptions.lang, nextMapOptions.lang);
      this.updateMapWithAPI('setRotation', this.mapOptions.rotation, nextMapOptions.rotation);
      this.updateMapWithAPI('setStatus', this.mapOptions.status, nextMapOptions.status);
      this.updateMapWithAPI('setDefaultCursor', this.mapOptions.defaultCursor, nextMapOptions.defaultCursor);
      this.updateMapWithAPI('setMapStyle', this.mapOptions.mapStyle, nextMapOptions.mapStyle);
      this.updateMapWithAPI('setFeatures', this.mapOptions.features, nextMapOptions.features);
      this.updateMapWithAPI('setDefaultLayer', this.mapOptions.defaultLayer, nextMapOptions.defaultLayer);
      this.updateMapWithAPI('setPitch', this.mapOptions.pitch, nextMapOptions.pitch);

      this.mapOptions = nextMapOptions;
    }

    /**
     * Remove event listeners.
     * Destroy AMap.Map instance.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var map = this.state.map;
      /**
       * There is a scenario where AMap has not been loaded when component unmounts.
       * AMapEventListeners and map instance are assigned only if AMap library has been loaded.
       */

      if (map !== void 0) {
        this.AMapEventListeners.forEach(function (listener) {
          window.AMap.event.removeListener(listener);
        });

        map.destroy();
      }
    }

    /**
     * Bind all events on map instance, and save event listeners which will be removed in
     * componentWillUnmount lifecycle.
     */

  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this2 = this;

      this.AMapEventListeners = [];

      /**
       * Construct event callbacks.
       */
      this.eventCallbacks = this.parseEvents();

      Object.keys(this.eventCallbacks).forEach(function (key) {
        var eventName = key.substring(2).toLowerCase();
        var handler = _this2.eventCallbacks[key];

        _this2.AMapEventListeners.push(window.AMap.event.addListener(_this2.map, eventName, handler));
      });
    }

    /**
     * Load AMap library and instantiate map object by calling AMap.Map.
     */

  }, {
    key: 'initAMap',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _props, appKey, locaVersion, protocol, uiVersion, version, AMapUI, Loca;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _props = this.props, appKey = _props.appKey, locaVersion = _props.locaVersion, protocol = _props.protocol, uiVersion = _props.uiVersion, version = _props.version;

                if (!(window.AMap === void 0)) {
                  _context2.next = 10;
                  break;
                }

                _context2.next = 4;
                return AMap.requireAMap({ appKey: appKey, protocol: protocol, version: version });

              case 4:
                /**
                 * Load AMapUI and Loca in parallel.
                 */
                AMapUI = AMap.requireAMapUI({ protocol: protocol, version: uiVersion });
                Loca = AMap.requireLoca({ appKey: appKey, protocol: protocol, version: locaVersion });
                _context2.next = 8;
                return AMapUI;

              case 8:
                _context2.next = 10;
                return Loca;

              case 10:

                this.map = new window.AMap.Map(this.mapContainer, _extends({}, this.mapOptions));

                this.bindEvents();

                this.setState({
                  map: this.map
                });

              case 13:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function initAMap() {
        return _ref5.apply(this, arguments);
      }

      return initAMap;
    }()

    /**
     * Return an object of all supported event callbacks.
    */

  }, {
    key: 'parseEvents',
    value: function parseEvents() {
      return {
        onComplete: (0, _createEventCallback2.default)('onComplete', this.map).bind(this),
        onClick: (0, _createEventCallback2.default)('onClick', this.map).bind(this),
        onDblClick: (0, _createEventCallback2.default)('onDblClick', this.map).bind(this),
        onMapMove: (0, _createEventCallback2.default)('onMapMove', this.map).bind(this),
        onHotspotClick: (0, _createEventCallback2.default)('onHotspotClick', this.map).bind(this),
        onHotspotOver: (0, _createEventCallback2.default)('onHotspotOver', this.map).bind(this),
        onHotspotOut: (0, _createEventCallback2.default)('onHotspotOut', this.map).bind(this),
        onMoveStart: (0, _createEventCallback2.default)('onMoveStart', this.map).bind(this),
        onMoveEnd: (0, _createEventCallback2.default)('onMoveEnd', this.map).bind(this),
        onZoomChange: (0, _createEventCallback2.default)('onZoomChange', this.map).bind(this),
        onZoomStart: (0, _createEventCallback2.default)('onZoomStart', this.map).bind(this),
        onZoomEnd: (0, _createEventCallback2.default)('onZoomEnd', this.map).bind(this),
        onMouseMove: (0, _createEventCallback2.default)('onMouseMove', this.map).bind(this),
        onMouseWheel: (0, _createEventCallback2.default)('onMouseWheel', this.map).bind(this),
        onMouseOver: (0, _createEventCallback2.default)('onMouseOver', this.map).bind(this),
        onMouseOut: (0, _createEventCallback2.default)('onMouseOut', this.map).bind(this),
        onMouseUp: (0, _createEventCallback2.default)('onMouseUp', this.map).bind(this),
        onMouseDown: (0, _createEventCallback2.default)('onMouseDown', this.map).bind(this),
        onRightClick: (0, _createEventCallback2.default)('onRightClick', this.map).bind(this),
        onDragStart: (0, _createEventCallback2.default)('onDragStart', this.map).bind(this),
        onDragging: (0, _createEventCallback2.default)('onDragging', this.map).bind(this),
        onDragEnd: (0, _createEventCallback2.default)('onDragEnd', this.map).bind(this),
        onResize: (0, _createEventCallback2.default)('onResize', this.map).bind(this),
        onTouchStart: (0, _createEventCallback2.default)('onTouchStart', this.map).bind(this),
        onTouchMove: (0, _createEventCallback2.default)('onTouchMove', this.map).bind(this),
        onTouchEnd: (0, _createEventCallback2.default)('onTouchEnd', this.map).bind(this)
      };
    }

    /**
     * Update AMap.Map instance with named API.
     * Call update API with next prop only if props to be compared are not identical.
     * Won't call API if prop does not change.
     */

  }, {
    key: 'updateMapWithAPI',
    value: function updateMapWithAPI(apiName, previousCompareProp, nextCompareProp, nextProp) {
      /**
       * nextProp can omit if next prop is identical to prop to be compared.
       */
      if (arguments.length === 3) {
        nextProp = nextCompareProp;
      }

      if (!(0, _isShallowEqual2.default)(previousCompareProp, nextCompareProp)) {
        this.map[apiName](nextProp);
      }
    }

    /**
     * Render a div element as root of AMap.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = this.props.children;
      var map = this.state.map;


      return _react2.default.createElement(
        'div',
        { ref: function ref(self) {
            _this3.mapContainer = self;
          }, style: mapContainerStyle },
        _react2.default.createElement(
          _AMapContext2.default.Provider,
          { value: map },
          map !== void 0 && children
        )
      );
    }
  }]);

  return AMap;
}(_react2.default.PureComponent), _class.propTypes = {
  /**
   * AMap JS App key.
   */
  appKey: _propTypes2.default.string.isRequired,
  /* eslint-disable-next-line react/no-unused-prop-types */
  bounds: _propTypes2.default.oneOfType([
  /**
   * South west and north east lng lat position.
   * i.e. [[soutWest], [northEast]]
   */
  _propTypes2.default.arrayOf(_propTypes2.default.arrayOf(_propTypes2.default.number)),
  /**
   * AMap.Bounds instance.
   */
  _propTypes2.default.object]),
  /**
   * Child components.
   */
  children: _propTypes2.default.node,
  /**
   * Loca library version.
   * Loca will be deprecated in the next major version. Please consider react-amap-2drender for
   * rendering map UI components with high performance.
   */
  locaVersion: _propTypes2.default.string,
  /**
   * Whether it is http or https.
   */
  protocol: _propTypes2.default.oneOf(['http', 'https']),
  /**
   * AMap UI version.
   */
  uiVersion: _propTypes2.default.string,
  /**
   * AMap javascript library version.
   */
  version: _propTypes2.default.string,
  /**
   * Event callback.
   * Signature:
   * (map, ...event) => void
   * map: AMap instance.
   * event: AMap event.
   */
  /* eslint-disable react/sort-prop-types,react/no-unused-prop-types */
  onComplete: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onDblClick: _propTypes2.default.func,
  onMapMove: _propTypes2.default.func,
  onHotspotClick: _propTypes2.default.func,
  onHotspotOver: _propTypes2.default.func,
  onHotspotOut: _propTypes2.default.func,
  onMoveStart: _propTypes2.default.func,
  onMoveEnd: _propTypes2.default.func,
  onZoomChange: _propTypes2.default.func,
  onZoomStart: _propTypes2.default.func,
  onZoomEnd: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  onMouseWheel: _propTypes2.default.func,
  onMouseOver: _propTypes2.default.func,
  onMouseOut: _propTypes2.default.func,
  onMouseUp: _propTypes2.default.func,
  onMouseDown: _propTypes2.default.func,
  onRightClick: _propTypes2.default.func,
  onDragStart: _propTypes2.default.func,
  onDragging: _propTypes2.default.func,
  onDragEnd: _propTypes2.default.func,
  onResize: _propTypes2.default.func,
  onTouchStart: _propTypes2.default.func,
  onTouchMove: _propTypes2.default.func,
  onTouchEnd: _propTypes2.default.func
  /* eslint-enable */
}, _class.defaultProps = {
  locaVersion: '1.0.5',
  protocol: 'https',
  version: '1.4.15',
  uiVersion: '1.0'
}, _temp);
exports.default = AMap;