'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp; /**
                    * Loca will be deprecated in the next major version. Please consider react-amap-2drender for
                    * rendering map UI components with high performance
                    */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _breakIfNotChildOfAMap = require('../utils/breakIfNotChildOfAMap');

var _breakIfNotChildOfAMap2 = _interopRequireDefault(_breakIfNotChildOfAMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Loca binding.
 */
var Loca = (_temp = _class = function (_React$Component) {
  _inherits(Loca, _React$Component);

  /**
   * Initialise Loca.
   */

  /**
   * AMap map instance.
   */
  function Loca(props, context) {
    _classCallCheck(this, Loca);

    var _this = _possibleConstructorReturn(this, (Loca.__proto__ || Object.getPrototypeOf(Loca)).call(this, props));

    var data = props.data,
        dataSetOptions = props.dataSetOptions,
        layerOptions = props.layerOptions,
        visualOptions = props.visualOptions;


    var map = context;

    (0, _breakIfNotChildOfAMap2.default)('Loca', map);

    var locaMap = new window.Loca(map);

    _this.loca = new window.Loca.VisualLayer(_extends({
      container: locaMap
    }, layerOptions));

    _this.loca.setData((0, _cloneDeep2.default)(data), (0, _cloneDeep2.default)(dataSetOptions));

    _this.loca.setOptions((0, _cloneDeep2.default)(visualOptions));

    _this.loca.render();
    return _this;
  }

  /**
   * Update this.loca by calling Loca methods.
   * @param  {Object} nextProps
   * @return {Boolean} - Prevent calling render function
   */


  _createClass(Loca, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var data = nextProps.data,
          dataSetOptions = nextProps.dataSetOptions,
          visualOptions = nextProps.visualOptions;


      this.loca.setData((0, _cloneDeep2.default)(data), (0, _cloneDeep2.default)(dataSetOptions));

      this.loca.setOptions((0, _cloneDeep2.default)(visualOptions));

      this.loca.render();

      return false;
    }

    /**
     * Destroy loca instance.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.loca.destroy();
    }

    /**
     * Render nothing.
     */

  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Loca;
}(_react2.default.Component), _class.contextType = _AMapContext2.default, _class.propTypes = {
  /**
   * @ignore
   */
  data: _propTypes2.default.array.isRequired,
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_data_option}
   */
  dataSetOptions: _propTypes2.default.shape({
    lnglat: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]).isRequired,
    type: _propTypes2.default.string
  }),
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_options}
   */
  layerOptions: _propTypes2.default.shape({
    blendMode: _propTypes2.default.string,
    eventSupport: _propTypes2.default.bool,
    fitView: _propTypes2.default.bool,
    shape: _propTypes2.default.string.isRequired,
    type: _propTypes2.default.string.isRequired,
    zIndex: _propTypes2.default.number
  }).isRequired,
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_visual_option}
   */
  visualOptions: _propTypes2.default.shape({
    invisible: _propTypes2.default.func,
    selectStyle: _propTypes2.default.object,
    source: _propTypes2.default.oneOfType([_propTypes2.default.instanceOf(HTMLCanvasElement), _propTypes2.default.instanceOf(HTMLImageElement), _propTypes2.default.string]),
    style: _propTypes2.default.object,
    unit: _propTypes2.default.string
  })
}, _temp);
exports.default = Loca;