'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _breakIfNotChildOfAMap = require('../utils/breakIfNotChildOfAMap');

var _breakIfNotChildOfAMap2 = _interopRequireDefault(_breakIfNotChildOfAMap);

var _cloneDeep = require('../utils/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _createEventCallback = require('../utils/createEventCallback');

var _createEventCallback2 = _interopRequireDefault(_createEventCallback);

var _isNullVoid = require('../utils/isNullVoid');

var _isNullVoid2 = _interopRequireDefault(_isNullVoid);

var _isShallowEqual = require('../utils/isShallowEqual');

var _isShallowEqual2 = _interopRequireDefault(_isShallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Fields that need to be deep copied.
 * AMap LBS library mutates options. Deep copy those options before passing to AMap so that
 * props won't be mutated.
 */
var NEED_DEEP_COPY_FIELDS = ['position'];

/**
 * Marker binding.
 * Marker has the same options as AMap.Marker unless highlighted below.
 * {@link http://lbs.amap.com/api/javascript-api/reference/overlay#marker}
 */
var Marker = (_temp = _class = function (_React$Component) {
  _inherits(Marker, _React$Component);

  _createClass(Marker, null, [{
    key: 'parseMarkerOptions',


    /**
     * Parse AMap.Marker options.
     * Named properties are event callbacks, other properties are marker options.
     */
    value: function parseMarkerOptions(props) {
      var onComplete = props.onComplete,
          onClick = props.onClick,
          onDblClick = props.onDblClick,
          onRightClick = props.onRightClick,
          onMouseMove = props.onMouseMove,
          onMouseOver = props.onMouseOver,
          onMouseOut = props.onMouseOut,
          onMouseDown = props.onMouseDown,
          onMouseUp = props.onMouseUp,
          onDragStart = props.onDragStart,
          onDragging = props.onDragging,
          onDragEnd = props.onDragEnd,
          onMoving = props.onMoving,
          onMoveEnd = props.onMoveEnd,
          onMoveAlong = props.onMoveAlong,
          onTouchStart = props.onTouchStart,
          onTouchMove = props.onTouchMove,
          onTouchEnd = props.onTouchEnd,
          markerOptions = _objectWithoutProperties(props, ['onComplete', 'onClick', 'onDblClick', 'onRightClick', 'onMouseMove', 'onMouseOver', 'onMouseOut', 'onMouseDown', 'onMouseUp', 'onDragStart', 'onDragging', 'onDragEnd', 'onMoving', 'onMoveEnd', 'onMoveAlong', 'onTouchStart', 'onTouchMove', 'onTouchEnd']);

      var icon = markerOptions.icon,
          _markerOptions$label = markerOptions.label,
          label = _markerOptions$label === undefined ? {} : _markerOptions$label,
          offset = markerOptions.offset;


      return _extends({}, markerOptions, {
        icon: function () {
          /**
           * Changing label to either null or undefined clears icon.
           */
          if ((0, _isNullVoid2.default)(icon)) return null;

          if (icon instanceof window.AMap.Icon) return icon;

          /**
           * Construct AMap.Icon instance with options.
           */
          return new window.AMap.Icon({
            image: icon.image,
            imageOffset: function () {
              if (icon.imageOffset instanceof window.AMap.Pixel) {
                return icon.imageOffset;
              }

              if (icon.imageOffset instanceof Array) {
                return new (Function.prototype.bind.apply(window.AMap.Pixel, [null].concat(_toConsumableArray(icon.imageOffset))))();
              }

              return new window.AMap.Pixel(0, 0);
            }(),
            /**
             * AMap.Icon understands both [x, y] and instance of AMap.Size.
             */
            imageSize: icon.imageSize,
            size: icon.size
          });
        }(),
        label: function () {
          /**
           * Changing label to either null or undefined clears label.
           */
          if ((0, _isNullVoid2.default)(label)) return null;

          return _extends({}, label, {
            // Will transform an array of two numbers into a Pixel instance
            offset: function () {
              if (label.offset instanceof window.AMap.Pixel) {
                return label.offset;
              }

              if (label.offset instanceof Array) {
                return new (Function.prototype.bind.apply(window.AMap.Pixel, [null].concat(_toConsumableArray(label.offset))))();
              }

              return new window.AMap.Pixel(0, 0);
            }()
          });
        }(),
        // Will transform an array of two numbers into a Pixel instance
        offset: function () {
          if (offset instanceof window.AMap.Pixel) {
            return offset;
          }

          if (offset instanceof Array) {
            return new (Function.prototype.bind.apply(window.AMap.Pixel, [null].concat(_toConsumableArray(offset))))();
          }

          return new window.AMap.Pixel(-10, -34);
        }()
      });
    }

    /**
     * Define event name mapping relations of react binding Marker and AMap.Marker.
     * Initialise AMap.Marker and bind events.
     * Fire complete action as soon as bezier curve has been created.
     */


    /**
     * AMap map instance.
     */

  }]);

  function Marker(props, context) {
    _classCallCheck(this, Marker);

    var _this = _possibleConstructorReturn(this, (Marker.__proto__ || Object.getPrototypeOf(Marker)).call(this, props));

    var onComplete = _this.props.onComplete;


    var map = context;

    (0, _breakIfNotChildOfAMap2.default)('Marker', map);

    _this.markerOptions = Marker.parseMarkerOptions(_this.props);

    _this.marker = _this.initMarker(map);

    _this.bindEvents();

    typeof onComplete === 'function' && onComplete(map, _this.marker);
    return _this;
  }

  /**
   * Update this.marker by calling AMap.Marker methods.
   */


  _createClass(Marker, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var nextMarkerOptions = Marker.parseMarkerOptions(nextProps);

      var newMarkerOptions = (0, _cloneDeep2.default)(nextMarkerOptions, NEED_DEEP_COPY_FIELDS);

      this.toggleVisible(this.markerOptions.visible, nextMarkerOptions.visible);

      this.updateMarkerWithAPI('setAnchor', this.markerOptions.anchor, nextMarkerOptions.anchor, newMarkerOptions.anchor);

      this.updateMarkerWithAPI('setOffset', this.markerOptions.offset, nextMarkerOptions.offset, newMarkerOptions.offset);

      this.updateMarkerWithAPI('setAnimation', this.markerOptions.animation, nextMarkerOptions.animation, newMarkerOptions.animation);

      this.updateMarkerWithAPI('setClickable', this.markerOptions.clickable, nextMarkerOptions.clickable, newMarkerOptions.clickable);

      this.updateMarkerWithAPI('setPosition', this.markerOptions.position, nextMarkerOptions.position, newMarkerOptions.position);

      this.updateMarkerWithAPI('setAngle', this.markerOptions.angle, nextMarkerOptions.angle, newMarkerOptions.angle);

      /**
       * WARNING: There is a known issue: Create Marker with label, then setLabel(null) to clear
       * label, then setIcon to change icon image, results label appears again.
       */
      this.updateMarkerWithAPI('setLabel', this.markerOptions.label, nextMarkerOptions.label, newMarkerOptions.label);

      this.updateMarkerWithAPI('setzIndex', this.markerOptions.zIndex, nextMarkerOptions.zIndex, newMarkerOptions.zIndex);

      this.updateMarkerWithAPI('setIcon', this.markerOptions.icon, nextMarkerOptions.icon, newMarkerOptions.icon);

      this.updateMarkerWithAPI('setDraggable', this.markerOptions.draggable, nextMarkerOptions.draggable, newMarkerOptions.draggable);

      this.updateMarkerWithAPI('setCursor', this.markerOptions.cursor, nextMarkerOptions.cursor, newMarkerOptions.cursor);

      this.updateMarkerWithAPI('setContent', this.markerOptions.content, nextMarkerOptions.content, newMarkerOptions.content);

      this.updateMarkerWithAPI('setTitle', this.markerOptions.title, nextMarkerOptions.title, newMarkerOptions.title);

      this.updateMarkerWithAPI('setShadow', this.markerOptions.shadow, nextMarkerOptions.shadow, newMarkerOptions.shadow);

      this.updateMarkerWithAPI('setShape', this.markerOptions.shape, nextMarkerOptions.shape, newMarkerOptions.shape);

      this.updateMarkerWithAPI('setExtData', this.markerOptions.extData, nextMarkerOptions.extData, newMarkerOptions.extData);

      this.markerOptions = nextMarkerOptions;

      return false;
    }

    /**
     * Remove event listeners.
     * Destroy marker instance.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.AMapEventListeners.forEach(function (listener) {
        window.AMap.event.removeListener(listener);
      });

      this.marker.setMap(null);
      this.marker = null;
    }

    /**
     * Bind all events on map instance, and save event listeners which will be removed in
     * componentWillUnmount lifecycle.
     */

  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this2 = this;

      this.AMapEventListeners = [];

      /**
       * Construct event callbacks.
       */
      var eventCallbacks = this.parseEvents();

      Object.keys(eventCallbacks).forEach(function (key) {
        var eventName = key.substring(2).toLowerCase();
        var handler = eventCallbacks[key];

        _this2.AMapEventListeners.push(window.AMap.event.addListener(_this2.marker, eventName, handler));
      });
    }

    /**
     * Initialise AMap.Marker
     */

  }, {
    key: 'initMarker',
    value: function initMarker(map) {
      var visible = this.props.visible;


      var newMarkerOptions = (0, _cloneDeep2.default)(this.markerOptions, NEED_DEEP_COPY_FIELDS);

      var marker = new window.AMap.Marker(newMarkerOptions);

      marker.setMap(map);

      if (visible === false) marker.hide();

      return marker;
    }

    /**
     * Return an object of all supported event callbacks.
     */

  }, {
    key: 'parseEvents',
    value: function parseEvents() {
      return {
        onClick: (0, _createEventCallback2.default)('onClick', this.marker).bind(this),
        onDblClick: (0, _createEventCallback2.default)('onDblClick', this.marker).bind(this),
        onRightClick: (0, _createEventCallback2.default)('onRightClick', this.marker).bind(this),
        onMouseMove: (0, _createEventCallback2.default)('onMouseMove', this.marker).bind(this),
        onMouseOver: (0, _createEventCallback2.default)('onMouseOver', this.marker).bind(this),
        onMouseOut: (0, _createEventCallback2.default)('onMouseOut', this.marker).bind(this),
        onMouseDown: (0, _createEventCallback2.default)('onMouseDown', this.marker).bind(this),
        onMouseUp: (0, _createEventCallback2.default)('onMouseUp', this.marker).bind(this),
        onDragStart: (0, _createEventCallback2.default)('onDragStart', this.marker).bind(this),
        onDragging: (0, _createEventCallback2.default)('onDragging', this.marker).bind(this),
        onDragEnd: (0, _createEventCallback2.default)('onDragEnd', this.marker).bind(this),
        onMoving: (0, _createEventCallback2.default)('onMoving', this.marker).bind(this),
        onMoveEnd: (0, _createEventCallback2.default)('onMoveEnd', this.marker).bind(this),
        onMoveAlong: (0, _createEventCallback2.default)('onMoveAlong', this.marker).bind(this),
        onTouchStart: (0, _createEventCallback2.default)('onTouchStart', this.marker).bind(this),
        onTouchMove: (0, _createEventCallback2.default)('onTouchMove', this.marker).bind(this),
        onTouchEnd: (0, _createEventCallback2.default)('onTouchEnd', this.marker).bind(this)
      };
    }

    /**
     * Hide or show marker.
     */

  }, {
    key: 'toggleVisible',
    value: function toggleVisible(previousProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(previousProp, nextProp)) {
        if (nextProp === true) this.marker.show();
        if (nextProp === false) this.marker.hide();
      }
    }

    /**
     * Update AMap.Marker instance with named API and given value.
     * Won't call API if the given value does not change.
     */

  }, {
    key: 'updateMarkerWithAPI',
    value: function updateMarkerWithAPI(apiName, previousProp, nextProp, newProp) {
      if (!(0, _isShallowEqual2.default)(previousProp, nextProp)) {
        this.marker[apiName](newProp);
      }
    }

    /**
     * Render nothing.
     */

  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Marker;
}(_react2.default.Component), _class.propTypes = {
  /* eslint-disable react/no-unused-prop-types */
  icon: _propTypes2.default.oneOfType([
  /**
   * AMap.Icon instance.
   */
  _propTypes2.default.object,
  /**
   * AMap.Icon options.
   */
  _propTypes2.default.shape({
    image: _propTypes2.default.string,
    imageOffset: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number),
    /**
     * AMap.Pixel instance.
     */
    _propTypes2.default.object]),
    imageSize: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number),
    /**
     * AMap.Size instance.
     */
    _propTypes2.default.object]),
    size: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number),
    /**
     * AMap.Size instance.
     */
    _propTypes2.default.object])
  }),
  /**
   * Image url.
   */
  _propTypes2.default.string]),
  label: _propTypes2.default.shape({
    /**
     * An array of two numbers or AMap.Pixel.
     */
    offset: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number),
    /**
     * AMap.Pixel instance.
     */
    _propTypes2.default.object])
  }),
  /**
   * An array of two numbers or AMap.Pixel.
   */
  offset: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.number),
  /**
   * AMap.Pixel instance.
   */
  _propTypes2.default.object]),
  /**
   * Show Marker by default, you can toggle show or hide by changing visible.
   */
  visible: _propTypes2.default.bool,
  /**
   * Event callback.
   * Signature:
   * (marker, ...event) => void
   * marker: AMap.Marker instance.
   * event: AMap event.
   */
  /* eslint-disable react/sort-prop-types,react/no-unused-prop-types */
  onComplete: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onDblClick: _propTypes2.default.func,
  onRightClick: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  onMouseOver: _propTypes2.default.func,
  onMouseOut: _propTypes2.default.func,
  onMouseDown: _propTypes2.default.func,
  onMouseUp: _propTypes2.default.func,
  onDragStart: _propTypes2.default.func,
  onDragging: _propTypes2.default.func,
  onDragEnd: _propTypes2.default.func,
  onMoving: _propTypes2.default.func,
  onMoveEnd: _propTypes2.default.func,
  onMoveAlong: _propTypes2.default.func,
  onTouchStart: _propTypes2.default.func,
  onTouchMove: _propTypes2.default.func,
  onTouchEnd: _propTypes2.default.func
  /* eslint-enable */
}, _class.defaultProps = {
  visible: true
}, _class.contextType = _AMapContext2.default, _temp);
exports.default = Marker;