'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _breakIfNotChildOfAMap = require('../utils/breakIfNotChildOfAMap');

var _breakIfNotChildOfAMap2 = _interopRequireDefault(_breakIfNotChildOfAMap);

var _isShallowEqual = require('../utils/isShallowEqual');

var _isShallowEqual2 = _interopRequireDefault(_isShallowEqual);

var _createEventCallback = require('../utils/createEventCallback');

var _createEventCallback2 = _interopRequireDefault(_createEventCallback);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * PathNavigator binding.
 * PathNavigator has the same config options as PathNavigator unless highlighted below.
 * For pathNavigator events usage please reference to pathNavigator events paragraph.
 * {@link http://lbs.amap.com/api/javascript-api/reference-amap-ui/mass-data/pathsimplifier#PathNavigator}
 * Besides, it can transform image into pathNavigatorStyle content.
 */
var PathNavigator = (_temp = _class = function (_React$Component) {
  _inherits(PathNavigator, _React$Component);

  _createClass(PathNavigator, null, [{
    key: 'parsePathNavigatorOptions',


    /**
     * Parse PathNavigator options.
     * Named properties are event callbacks, other properties are pathNavigator options.
     */

    /**
     * AMap map instance.
     */
    value: function parsePathNavigatorOptions(props) {
      var pathIndex = props.pathIndex,
          pathSimplifier = props.pathSimplifier,
          PathSimplifierClass = props.PathSimplifierClass,
          onComplete = props.onComplete,
          onStart = props.onStart,
          onPause = props.onPause,
          onMove = props.onMove,
          onStop = props.onStop,
          pathNavigatorOptions = _objectWithoutProperties(props, ['pathIndex', 'pathSimplifier', 'PathSimplifierClass', 'onComplete', 'onStart', 'onPause', 'onMove', 'onStop']);

      return _extends({}, pathNavigatorOptions, {
        pathNavigatorStyle: _extends({}, pathNavigatorOptions.pathNavigatorStyle, {
          content: function () {
            if (pathNavigatorOptions.pathNavigatorStyle === void 0) {
              return 'defaultPathNavigator';
            }

            var content = pathNavigatorOptions.pathNavigatorStyle.content;


            if (typeof content === 'string' && content !== 'defaultPathNavigator' && content !== 'circle' && content !== 'none') {
              return PathSimplifierClass.Render.Canvas.getImageContent(content, function () {
                pathSimplifier.renderLater();
              }, function () {
                throw Error('The image could not be loaded.');
              });
            }

            return content || 'defaultPathNavigator';
          }()
        })
      });
    }

    /**
     * Define event name mapping relations of react binding PathNavigator.
     * Create pathNavigator and bind events.
     * Binding onComplete event on pathNavigator instance.
     */

  }]);

  function PathNavigator(props, context) {
    _classCallCheck(this, PathNavigator);

    var _this = _possibleConstructorReturn(this, (PathNavigator.__proto__ || Object.getPrototypeOf(PathNavigator)).call(this, props));

    var onComplete = props.onComplete,
        pathSimplifier = props.pathSimplifier;


    var map = context;

    (0, _breakIfNotChildOfAMap2.default)('PathNavigator', pathSimplifier, 'PathSimplifier');

    _this.pathNavigatorOptions = PathNavigator.parsePathNavigatorOptions(props);

    _this.pathNavigator = _this.createPathNavigator(_this.pathNavigatorOptions);

    _this.eventCallbacks = _this.parseEvents();

    _this.bindEvents(_this.pathNavigator, _this.eventCallbacks);

    onComplete && onComplete(map, _this.pathNavigator, pathSimplifier);
    return _this;
  }

  /**
   * Update this.pathNavigator by calling pathNavigator methods.
   * @param  {Object} nextProps
   * @return {Boolean} - Prevent calling render function
   */


  _createClass(PathNavigator, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var nextPathNavigatorOptions = PathNavigator.parsePathNavigatorOptions(nextProps);

      this.updatePathNavigatorWithApi('setSpeed', this.pathNavigatorOptions.speed, nextPathNavigatorOptions.speed);

      this.setRange(this.pathNavigatorOptions.range, nextPathNavigatorOptions.range);

      this.pathNavigatorOptions = nextPathNavigatorOptions;

      return false;
    }

    /**
     * Remove event listeners.
     * Destroy pathNavigator instance.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this2 = this;

      Object.keys(this.eventCallbacks).forEach(function (key) {
        var eventName = key.substring(2).toLowerCase();
        var handler = _this2.eventCallbacks[key];

        _this2.pathNavigator.off(eventName, handler);
      });

      this.pathNavigator.destroy();
      this.pathNavigator = null;
    }

    /**
     * Update pathNavigator range.
     * @param  {Object} currentProp - Current value
     * @param  {Object} nextProp - Next value
     */

  }, {
    key: 'setRange',
    value: function setRange(currentProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(currentProp, nextProp)) {
        this.pathNavigator.setRange(nextProp[0], nextProp[1]);
      }
    }

    /**
     * Bind all events on pathNavigator instance.
     * Save event listeners.
     * Later to be removed in componentWillUnmount lifecycle.
     * @param  {Object} pathNavigator - PathNavigator instance
     * @param  {Object} eventCallbacks - An object of all event callbacks
     */

  }, {
    key: 'bindEvents',
    value: function bindEvents(pathNavigator, eventCallbacks) {
      this.AMapEventListeners = [];

      Object.keys(eventCallbacks).forEach(function (key) {
        var eventName = key.substring(2).toLowerCase();
        var handler = eventCallbacks[key];

        pathNavigator.on(eventName, handler);
      });
    }

    /**
     * Create pathNavigator.
     * @param {Object} pathNavigatorOptions - PathNavigator options
     * @return {PathNavigator}
     */

  }, {
    key: 'createPathNavigator',
    value: function createPathNavigator(pathNavigatorOptions) {
      var _props = this.props,
          pathIndex = _props.pathIndex,
          pathSimplifier = _props.pathSimplifier;


      var pathNavigator = pathSimplifier.createPathNavigator(pathIndex, pathNavigatorOptions);

      return pathNavigator;
    }

    /**
     * Return an object of all supported event callbacks.
     */

  }, {
    key: 'parseEvents',
    value: function parseEvents() {
      return {
        onStart: (0, _createEventCallback2.default)('onStart', this.pathNavigator).bind(this),
        onPause: (0, _createEventCallback2.default)('onPause', this.pathNavigator).bind(this),
        onMove: (0, _createEventCallback2.default)('onMove', this.pathNavigator).bind(this),
        onStop: (0, _createEventCallback2.default)('onStop', this.pathNavigator).bind(this)
      };
    }

    /**
     * Update pathNavigator instance with named api and given value.
     * Won't call api if the given value does not change
     * @param  {string} apiName - PathNavigator instance update method name
     * @param  {Object} currentProp - Current value
     * @param  {Object} nextProp - Next value
     */

  }, {
    key: 'updatePathNavigatorWithApi',
    value: function updatePathNavigatorWithApi(apiName, currentProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(currentProp, nextProp)) {
        this.pathNavigator[apiName](nextProp);
      }
    }

    /**
     * Render nothing.
     */

  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return PathNavigator;
}(_react2.default.Component), _class.contextType = _AMapContext2.default, _class.propTypes = {
  /**
   * PathSimplifier path index.
   */
  pathIndex: _propTypes2.default.number.isRequired,
  /**
   * AMapUI pathSimplifier instance.
   */
  pathSimplifier: _propTypes2.default.object,
  /**
   * AMapUI pathSimplifier class function.
   */
  PathSimplifierClass: _propTypes2.default.func, // eslint-disable-line react/no-unused-prop-types
  /* eslint-disable react/sort-prop-types,react/no-unused-prop-types */
  /**
   * Event callback.
   *
   * @param {AMap.Map} map                  - AMap.Map instance
   * @param {PathNavigator} PathNavigator   - PathNavigator instance
   * @param {Object} event                  - PathNavigator event parameters
   */
  onComplete: _propTypes2.default.func,
  onStart: _propTypes2.default.func,
  onPause: _propTypes2.default.func,
  onMove: _propTypes2.default.func,
  onStop: _propTypes2.default.func
  /* eslint-enable */
}, _temp);
exports.default = PathNavigator;