'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _camelCase = require('lodash/camelCase');

var _camelCase2 = _interopRequireDefault(_camelCase);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _breakIfNotChildOfAMap = require('../utils/breakIfNotChildOfAMap');

var _breakIfNotChildOfAMap2 = _interopRequireDefault(_breakIfNotChildOfAMap);

var _isShallowEqual = require('../utils/isShallowEqual');

var _isShallowEqual2 = _interopRequireDefault(_isShallowEqual);

var _createEventCallback = require('../utils/createEventCallback');

var _createEventCallback2 = _interopRequireDefault(_createEventCallback);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * PathSimplifier binding.
 * PathSimplifier has the same config options as AMapUI.PathSimplifier unless highlighted below.
 * For PathSimplifier events usage please reference to AMapUI.PathSimplifier events paragraph.
 * {@link http://lbs.amap.com/api/javascript-api/reference-amap-ui/mass-data/pathsimplifier}
 * AMapUI.PathSimplifier opens api for updating zIndex and data only,
 * therefore, only these two props are reactive.
 */
var PathSimplifier = (_temp = _class = function (_React$Component) {
  _inherits(PathSimplifier, _React$Component);

  _createClass(PathSimplifier, null, [{
    key: 'getDerivedStateFromProps',


    /**
     * PathNavigator instance should be recreated once nextProps.data is changed.
     * It will render null in the render(),
     * then call setState() immediately in componentDidUpdate() to updated
     * isShouldDestoryPathNavigator to false, finally rerender.
     */

    /**
     * AMap map instance.
     */
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (!(0, _isShallowEqual2.default)(nextProps.data, prevState.data)) {
        return {
          data: nextProps.data,
          isShouldDestoryPathNavigator: true
        };
      }

      return null;
    }

    /**
     * Parse AMapUI.PathSimplifier options.
     * Named properties are event callbacks, other properties are pathSimplifier options.
     */

  }, {
    key: 'parsePathSimplifierOptions',
    value: function parsePathSimplifierOptions(props) {
      var onComplete = props.onComplete,
          onPathClick = props.onPathClick,
          onPathMouseover = props.onPathMouseover,
          onPathMouseout = props.onPathMouseout,
          onPointClick = props.onPointClick,
          onPointMouseover = props.onPointMouseover,
          onPointMouseout = props.onPointMouseout,
          pathSimplifierOptions = _objectWithoutProperties(props, ['onComplete', 'onPathClick', 'onPathMouseover', 'onPathMouseout', 'onPointClick', 'onPointMouseover', 'onPointMouseout']);

      return _extends({}, pathSimplifierOptions);
    }
  }]);

  /**
   * Define event name mapping relations of react binding PathSimplifier and AMapUI.PathSimplifier.
   */
  function PathSimplifier(props, context) {
    _classCallCheck(this, PathSimplifier);

    var _this = _possibleConstructorReturn(this, (PathSimplifier.__proto__ || Object.getPrototypeOf(PathSimplifier)).call(this, props));

    _this.state = {
      data: [],
      isShouldDestoryPathNavigator: false,
      pathSimplifier: void 0
    };


    var map = context;

    (0, _breakIfNotChildOfAMap2.default)('PathSimplifier', map);
    return _this;
  }

  /**
   * Asynchronously load PathSimplifier module.
   * Initialise AMapUI.PathSimplifier and bind events.
   * Binding onComplete event on pathSimplifier instance.
   */


  _createClass(PathSimplifier, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      window.AMapUI.loadUI(['misc/PathSimplifier'], function (PathSimplifierClass) {
        var map = _this2.context;

        _this2.PathSimplifierClass = PathSimplifierClass;

        _this2.pathSimplifierOptions = _extends({}, PathSimplifier.parsePathSimplifierOptions(_this2.props), {
          map: map
        });

        _this2.pathSimplifier = new PathSimplifierClass(_this2.pathSimplifierOptions);

        _this2.eventCallbacks = _this2.parseEvents();

        _this2.bindEvents(_this2.pathSimplifier, _this2.eventCallbacks);

        if (_this2.props.visible === false) _this2.pathSimplifier.hide();

        _this2.props.onComplete && _this2.props.onComplete(map, _this2.pathSimplifier);

        _this2.setState({
          data: _this2.pathSimplifierOptions.data,
          pathSimplifier: _this2.pathSimplifier
        });
      });
    }

    /**
     * Update this.pathSimplifier by calling AMapUI.PathSimplifier methods.
     * @param {Object} prevProps - Previous props
     * @param {Object} prevState - Previous state
     */

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.pathSimplifier === void 0) {
        return;
      }

      // Recreate pathNavigator
      if (prevState.isShouldDestoryPathNavigator === true) {
        this.allowToCreatePathNavigator(prevState);
      }

      var nextPathSimplifierOptions = PathSimplifier.parsePathSimplifierOptions(this.props);

      this.updatePathSimplifierWithApi('setZIndexOfPath', this.pathSimplifierOptions.zIndex, nextPathSimplifierOptions.zIndex);

      this.updatePathSimplifierWithApi('setData', this.pathSimplifierOptions.data, nextPathSimplifierOptions.data);

      this.toggleVisible(this.pathSimplifierOptions.visible, nextPathSimplifierOptions.visible);

      this.pathSimplifierOptions = nextPathSimplifierOptions;
    }

    /**
     * Remove event listeners.
     * Remove pathSimplifier.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this3 = this;

      /**
       * The eventCallbacks and pathSimplifier variables are assigned
       * after the asynchronous PathSimplifier module has been loaded.
       * If the resource has not been downloaded
       * before the component will unmount, an error will be thrown.
       */
      if (this.eventCallbacks !== void 0) {
        Object.keys(this.eventCallbacks).forEach(function (key) {
          var eventName = (0, _camelCase2.default)(key.substring(2));
          var handler = _this3.eventCallbacks[key];

          _this3.pathSimplifier.off(eventName, handler);
        });
      }

      if (this.pathSimplifier !== void 0) {
        this.pathSimplifier.setData();
        this.pathSimplifier = null;
      }
    }

    /**
     * Allow to create pathNavigator after previous PathNavigator instance is destoryed.
     * @param  {Object} prevState - Previous state
     */

  }, {
    key: 'allowToCreatePathNavigator',
    value: function allowToCreatePathNavigator(prevState) {
      this.setState(_extends({}, prevState, {
        isShouldDestoryPathNavigator: false
      }));
    }

    /**
     * Return an object of all supported event callbacks.
     */

  }, {
    key: 'parseEvents',
    value: function parseEvents() {
      return {
        onPathClick: (0, _createEventCallback2.default)('onPathClick', this.pathSimplifier).bind(this),
        onPathMouseover: (0, _createEventCallback2.default)('onPathMouseover', this.pathSimplifier).bind(this),
        onPathMouseout: (0, _createEventCallback2.default)('onPathMouseout', this.pathSimplifier).bind(this),
        onPointClick: (0, _createEventCallback2.default)('onPointClick', this.pathSimplifier).bind(this),
        onPointMouseover: (0, _createEventCallback2.default)('onPointMouseover', this.pathSimplifier).bind(this),
        onPointMouseout: (0, _createEventCallback2.default)('onPointMouseout', this.pathSimplifier).bind(this)
      };
    }

    /**
     * Bind all events on pathSimplifier instance.
     * Save event listeners.
     * Later to be removed in componentWillUnmount lifecycle.
     * @param  {AMapUI.PathSimplifier} pathSimplifier - AMapUI.PathSimplifier instance
     * @param  {Object} eventCallbacks - An object of all event callbacks
     */

  }, {
    key: 'bindEvents',
    value: function bindEvents(pathSimplifier, eventCallbacks) {
      var _this4 = this;

      Object.keys(eventCallbacks).forEach(function (key) {
        var eventName = (0, _camelCase2.default)(key.substring(2));
        var handler = eventCallbacks[key];

        _this4.pathSimplifier.on(eventName, handler);
      });
    }

    /**
     * Update AMapUI.PathSimplifier instance with named api and given value.
     * Won't call api if the given value does not change.
     * @param  {string} apiName - AMapUI.PathSimplifier instance update method name
     * @param  {Object} currentProp - Current value
     * @param  {Object} nextProp - Next value
     */

  }, {
    key: 'updatePathSimplifierWithApi',
    value: function updatePathSimplifierWithApi(apiName, currentProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(currentProp, nextProp)) {
        this.pathSimplifier[apiName](nextProp);
      }
    }

    /**
     * Hide or show pathSimplifier.
     * @param  {Object} currentProp - Current value
     * @param  {Object} nextProp - Next value
     */

  }, {
    key: 'toggleVisible',
    value: function toggleVisible(currentProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(currentProp, nextProp)) {
        if (nextProp === true) this.pathSimplifier.show();
        if (nextProp === false) this.pathSimplifier.hide();
      }
    }

    /**
     * Destory pathNavigator once the pathSimplifier data is changed.
     * Pass map object instantiated by AMap.Map、pathSimplifier instance
     * and pathSimplifierClass to all direct decendents.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var children = this.props.children;
      var _state = this.state,
          isShouldDestoryPathNavigator = _state.isShouldDestoryPathNavigator,
          pathSimplifier = _state.pathSimplifier;


      var map = this.context;

      var childrenElement = function childrenElement() {
        if (_react2.default.isValidElement(children)) {
          // Single element
          return _react2.default.cloneElement(children, {
            map: map,
            pathSimplifier: pathSimplifier,
            PathSimplifierClass: _this5.PathSimplifierClass
          });
        }

        if (children.length !== void 0) {
          // An array of elements
          return _react2.default.Children.map(children, function (child) {
            if (_react2.default.isValidElement(child)) {
              return _react2.default.cloneElement(child, {
                map: map,
                pathSimplifier: pathSimplifier,
                PathSimplifierClass: _this5.PathSimplifierClass
              });
            }
            return void 0;
          });
        }

        return null;
      };

      /**
       * Destory pathNavigator.
       */
      if (isShouldDestoryPathNavigator === true) {
        return null;
      }

      return pathSimplifier !== void 0 && children !== void 0 && childrenElement();
    }
  }]);

  return PathSimplifier;
}(_react2.default.Component), _class.contextType = _AMapContext2.default, _class.propTypes = {
  /**
   * Child components.
   */
  children: _propTypes2.default.node,
  /**
   * Shows PathSimplifier by default, you can toggle show or hide by setting visible.
   */
  visible: _propTypes2.default.bool,
  /* eslint-disable react/sort-prop-types,react/no-unused-prop-types */
  /**
   * Event callback.
   *
   * @param {AMap.Map} map                    - AMap.Map instance
   * @param {PathSimplifier} PathSimplifier   - PathSimplifier instance
   * @param {Object} event                    - PathSimplifier event parameters
   */
  onComplete: _propTypes2.default.func,
  onPathClick: _propTypes2.default.func,
  onPathMouseover: _propTypes2.default.func,
  onPathMouseout: _propTypes2.default.func,
  onPointClick: _propTypes2.default.func,
  onPointMouseover: _propTypes2.default.func,
  onPointMouseout: _propTypes2.default.func
  /* eslint-enable */
}, _temp);
exports.default = PathSimplifier;