'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AMapContext = require('../AMapContext');

var _AMapContext2 = _interopRequireDefault(_AMapContext);

var _breakIfNotChildOfAMap = require('../utils/breakIfNotChildOfAMap');

var _breakIfNotChildOfAMap2 = _interopRequireDefault(_breakIfNotChildOfAMap);

var _createEventCallback = require('../utils/createEventCallback');

var _createEventCallback2 = _interopRequireDefault(_createEventCallback);

var _isShallowEqual = require('../utils/isShallowEqual');

var _isShallowEqual2 = _interopRequireDefault(_isShallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * TileLayerTraffic binding.
 * TileLayerTraffic has the same options as AMap.TileLayer.Traffic unless highlighted below.
 * {@link http://lbs.amap.com/api/javascript-api/reference/layer#TileLayer.Traffic}
 */
var TileLayerTraffic = (_temp = _class = function (_React$Component) {
  _inherits(TileLayerTraffic, _React$Component);

  _createClass(TileLayerTraffic, null, [{
    key: 'parseTileLayerTrafficOptions',


    /**
     * Parse AMap.TileLayer.Traffic options.
     * Named properties are event callbacks, other properties are tileLayerTraffic options.
     */
    value: function parseTileLayerTrafficOptions(props) {
      var onComplete = props.onComplete,
          tileLayerTrafficOptions = _objectWithoutProperties(props, ['onComplete']);

      return tileLayerTrafficOptions;
    }

    /**
     * Define event name mapping relations of react binding TileLayerTraffic and
     * AMap.TileLayer.Traffic.
     * Initialise AMap.TileLayer.Traffic and bind events.
     */


    /**
     * AMap map instance.
     */

  }]);

  function TileLayerTraffic(props, context) {
    _classCallCheck(this, TileLayerTraffic);

    var _this = _possibleConstructorReturn(this, (TileLayerTraffic.__proto__ || Object.getPrototypeOf(TileLayerTraffic)).call(this, props));

    var map = context;

    (0, _breakIfNotChildOfAMap2.default)('TileLayerTraffic', map);

    _this.tileLayerTrafficOptions = TileLayerTraffic.parseTileLayerTrafficOptions(_this.props);

    _this.tileLayerTraffic = _this.initTileLayerTraffic(map);

    _this.bindEvents();
    return _this;
  }

  /**
   * Update this.tileLayerTraffic by calling AMap.TileLayer.Traffic methods.
   */


  _createClass(TileLayerTraffic, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var nextTileLayerTrafficOptions = TileLayerTraffic.parseTileLayerTrafficOptions(nextProps);

      this.toggleVisible(this.tileLayerTrafficOptions.visible, nextTileLayerTrafficOptions.visible);

      this.updateTileLayerTrafficWithAPI('setOpacity', this.tileLayerTrafficOptions.opacity, nextTileLayerTrafficOptions.opacity);

      this.updateTileLayerTrafficWithAPI('setzIndex', this.tileLayerTrafficOptions.zIndex, nextTileLayerTrafficOptions.zIndex);

      this.tileLayerTrafficOptions = nextTileLayerTrafficOptions;

      return false;
    }

    /**
     * Remove event listeners.
     * Destroy tileLayerTraffic instance.
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.AMapEventListeners.forEach(function (listener) {
        window.AMap.event.removeListener(listener);
      });

      this.tileLayerTraffic.setMap(null);
      this.tileLayerTraffic = null;
    }

    /**
     * Bind all events on map instance, and save event listeners which will be removed in
     * componentWillUnmount lifecycle.
     */

  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this2 = this;

      this.AMapEventListeners = [];

      /**
       * Construct event callbacks.
       */
      var eventCallbacks = this.parseEvents();

      Object.keys(eventCallbacks).forEach(function (key) {
        var eventName = key.substring(2).toLowerCase();
        var handler = eventCallbacks[key];

        _this2.AMapEventListeners.push(window.AMap.event.addListener(_this2.tileLayerTraffic, eventName, handler));
      });
    }

    /**
     * Initialise traffic tileLayer.
     */

  }, {
    key: 'initTileLayerTraffic',
    value: function initTileLayerTraffic(map) {
      var visible = this.props.visible;


      var tileLayerTraffic = new window.AMap.TileLayer.Traffic(this.tileLayerTrafficOptions);

      tileLayerTraffic.setMap(map);

      if (visible === false) tileLayerTraffic.hide();

      return tileLayerTraffic;
    }

    /**
     * Return an object of all supported event callbacks.
     */

  }, {
    key: 'parseEvents',
    value: function parseEvents() {
      return {
        onComplete: (0, _createEventCallback2.default)('onComplete', this.tileLayerTraffic).bind(this)
      };
    }

    /**
     * Hide or show tileLayerTraffic.
     */

  }, {
    key: 'toggleVisible',
    value: function toggleVisible(previousProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(previousProp, nextProp)) {
        if (nextProp === true) this.tileLayerTraffic.show();
        if (nextProp === false) this.tileLayerTraffic.hide();
      }
    }

    /**
     * Update AMap.TileLayer.Traffic instance with named API and given value.
     * Won't call API if the given value does not change.
     */

  }, {
    key: 'updateTileLayerTrafficWithAPI',
    value: function updateTileLayerTrafficWithAPI(apiName, previousProp, nextProp) {
      if (!(0, _isShallowEqual2.default)(previousProp, nextProp)) {
        this.tileLayerTraffic[apiName](nextProp);
      }
    }

    /**
     * Render nothing.
     */

  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return TileLayerTraffic;
}(_react2.default.Component), _class.propTypes = {
  /**
   * Shows TileLayerTraffic by default, you can toggle show or hide by setting config.
   */
  visible: _propTypes2.default.bool,
  /**
   * Event callback.
   * Signature:
   * (tileLayerTraffic, ...event) => void
   * tileLayerTraffic: AMap.TileLayer.Traffic instance.
   * event: AMap event.
   */
  /* eslint-disable react/sort-prop-types,react/no-unused-prop-types */
  onComplete: _propTypes2.default.func
  /* eslint-enable */
}, _class.defaultProps = {
  visible: true
}, _class.contextType = _AMapContext2.default, _temp);
exports.default = TileLayerTraffic;