var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

/**
 * Loca will be deprecated in the next major version. Please consider react-amap-2drender for
 * rendering map UI components with high performance
 */
import React from 'react';
import PropTypes from 'prop-types';
import cloneDeep from 'lodash/cloneDeep';
import AMapContext from '../AMapContext';
import breakIfNotChildOfAMap from '../utils/breakIfNotChildOfAMap';

/**
 * Loca binding.
 */
let Loca = (_temp = _class = class Loca extends React.Component {

  /**
   * Initialise Loca.
   */

  /**
   * AMap map instance.
   */
  constructor(props, context) {
    super(props);

    const {
      data,
      dataSetOptions,
      layerOptions,
      visualOptions
    } = props;

    const map = context;

    breakIfNotChildOfAMap('Loca', map);

    const locaMap = new window.Loca(map);

    this.loca = new window.Loca.VisualLayer(_extends({
      container: locaMap
    }, layerOptions));

    this.loca.setData(cloneDeep(data), cloneDeep(dataSetOptions));

    this.loca.setOptions(cloneDeep(visualOptions));

    this.loca.render();
  }

  /**
   * Update this.loca by calling Loca methods.
   * @param  {Object} nextProps
   * @return {Boolean} - Prevent calling render function
   */
  shouldComponentUpdate(nextProps) {
    const {
      data,
      dataSetOptions,
      visualOptions
    } = nextProps;

    this.loca.setData(cloneDeep(data), cloneDeep(dataSetOptions));

    this.loca.setOptions(cloneDeep(visualOptions));

    this.loca.render();

    return false;
  }

  /**
   * Destroy loca instance.
   */
  componentWillUnmount() {
    this.loca.destroy();
  }

  /**
   * Render nothing.
   */
  render() {
    return null;
  }
}, _class.contextType = AMapContext, _class.propTypes = {
  /**
   * @ignore
   */
  data: PropTypes.array.isRequired,
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_data_option}
   */
  dataSetOptions: PropTypes.shape({
    lnglat: PropTypes.oneOfType([PropTypes.func, PropTypes.string]).isRequired,
    type: PropTypes.string
  }),
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_options}
   */
  layerOptions: PropTypes.shape({
    blendMode: PropTypes.string,
    eventSupport: PropTypes.bool,
    fitView: PropTypes.bool,
    shape: PropTypes.string.isRequired,
    type: PropTypes.string.isRequired,
    zIndex: PropTypes.number
  }).isRequired,
  /**
   * @{@link http://lbs.amap.com/api/loca-api/api-manual#layer_visual_option}
   */
  visualOptions: PropTypes.shape({
    invisible: PropTypes.func,
    selectStyle: PropTypes.object,
    source: PropTypes.oneOfType([PropTypes.instanceOf(HTMLCanvasElement), PropTypes.instanceOf(HTMLImageElement), PropTypes.string]),
    style: PropTypes.object,
    unit: PropTypes.string
  })
}, _temp);


export default Loca;