'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (callbackName, target) {
  return function eventCallback() {
    var callback = this.props[callbackName];
    if (typeof callback === 'function') {
      for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }

      /**
       * Target is map instance if event is watched in AMap.
       * Target is circle instance if event is watched in Circle.
       * Map instance should be access via context.
       */
      callback.apply(undefined, [target].concat(params));
    }
  };
};