'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * Compare two numbers.
                                                                                                                                                                                                                                                                               * @param  {Object} objA
                                                                                                                                                                                                                                                                               * @param  {Object} objB
                                                                                                                                                                                                                                                                               * @return {Boolean}
                                                                                                                                                                                                                                                                               */


exports.default = function (objA, objB) {
  // Test case: Primitive types
  if (Object.is(objA, objB)) {
    return true;
  }

  // Test case: NaN
  if (Number.isNaN(objA) && Number.isNaN(objB)) {
    return true;
  }

  // Exclude null variables, undefined and functions
  if ((typeof objA === 'undefined' ? 'undefined' : _typeof(objA)) !== 'object' || objA === null || (typeof objB === 'undefined' ? 'undefined' : _typeof(objB)) !== 'object' || objB === null) {
    return false;
  }

  var keysA = Object.keys(objA);
  var keysB = Object.keys(objB);

  if (keysA.length !== keysB.length) {
    return false;
  }

  // Test for A's keys different from B.
  for (var i = 0; i < keysA.length; i += 1) {
    if (!objB.hasOwnProperty(keysA[i]) || !Object.is(objA[keysA[i]], objB[keysA[i]])) {
      return false;
    }
  }

  return true;
};